> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Search runs

> Search for runs that satisfy expressions. Search expressions can use :ref:`mlflowMetric` and
:ref:`mlflowParam` keys.



## OpenAPI

````yaml /api-specs/cloud/public-api.json post /api/2.0/mlflow/runs/search
openapi: 3.0.3
info:
  title: Domino Public API
  description: Reference for Domino's public REST API endpoints.
  version: 6.4.0
  x-catalog-key: nucleus
servers:
  - url: https://mycluster.domino.tech
    description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
security: []
tags:
  - name: Projects
  - name: Project templates
  - name: Workspaces
  - name: Jobs
  - name: HPC Jobs
  - name: Environments
  - name: Hardware Tiers
  - name: Datasets
  - name: Data Sources
  - name: GenAI
  - name: AI Systems
  - name: MLflow experiments and runs
  - name: MLflow models
  - name: MLflow artifacts
  - name: MLflow traces
  - name: Apps
  - name: App versions
  - name: App instances
  - name: Model APIs
  - name: Registered models
  - name: Model deployment
  - name: Extensions
  - name: Cost and billing
  - name: Users and organizations
  - name: Service accounts
  - name: Personal Access Tokens
  - name: Personal Access Tokens (admin)
  - name: Audit Trail
  - name: Custom metrics
  - name: PPM
  - name: Model Monitoring models
  - name: Model Monitoring drift and quality
  - name: Model Monitoring settings
  - name: Model Monitoring authentication
  - name: Governance bundles
  - name: Governance policies
  - name: Governance evidence and results
  - name: Governance operations
  - name: NetApp Volumes
  - name: NetApp Volumes snapshots
  - name: NetApp Volumes filesystems
  - name: NetApp Volumes transfers
  - name: Tags
  - name: Properties
externalDocs:
  description: OpenAPI
  url: https://swagger.io/resources/open-api/
paths:
  /api/2.0/mlflow/runs/search:
    post:
      tags:
        - MLflow experiments and runs
      description: >-
        Search for runs that satisfy expressions. Search expressions can use
        :ref:`mlflowMetric` and

        :ref:`mlflowParam` keys.
      operationId: runs.Search
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/mlflow-proxy_SearchRunsRequest'
      responses:
        '200':
          description: Runs matching search
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/mlflow-proxy_SearchRunsResponse'
        default:
          $ref: '#/components/responses/mlflow-proxy_MLflowNativeError'
components:
  schemas:
    mlflow-proxy_SearchRunsRequest:
      properties:
        experiment_ids:
          description: List of experiment IDs to search over.
          items:
            type: string
          type: array
        filter:
          description: >-
            A filter expression over params, metrics, and tags, that allows
            returning a subset of

            runs. The syntax is a subset of SQL that supports ANDing together
            binary operations

            between a param, metric, or tag and a constant.


            Example: ``metrics.rmse < 1 and params.model_class =
            'LogisticRegression'``


            You can select columns with special characters (hyphen, space,
            period, etc.) by using double quotes:

            ``metrics."model class" = 'LinearRegression' and tags."user-name" =
            'Tomas'``


            Supported operators are ``=``, ``!=``, ``>``, ``>=``, ``<``, and
            ``<=``.
          type: string
        max_results:
          default: 1000
          description: Maximum number of runs desired. Max threshold is 50000
          oneOf:
            - type: integer
              format: int32
            - type: string
        order_by:
          description: >-
            List of columns to be ordered by, including attributes, params,
            metrics, and tags with an

            optional "DESC" or "ASC" annotation, where "ASC" is the default.

            Example: ["params.input DESC", "metrics.alpha ASC", "metrics.rmse"]

            Tiebreaks are done by start_time DESC followed by run_id for runs
            with the same start time

            (and this is the default ordering criterion if order_by is not
            provided).
          items:
            type: string
          type: array
        page_token:
          description: ''
          type: string
        run_view_type:
          default: ACTIVE_ONLY
          description: |-
            Whether to display only active, only deleted, or all runs.
            Defaults to only active runs.
          enum:
            - ACTIVE_ONLY
            - DELETED_ONLY
            - ALL
          type: string
      type: object
    mlflow-proxy_SearchRunsResponse:
      properties:
        next_page_token:
          description: ''
          type: string
        runs:
          description: Runs that match the search criteria.
          items:
            $ref: '#/components/schemas/mlflow-proxy_Run'
          type: array
      type: object
    mlflow-proxy_Run:
      description: >-
        Run metadata (name, start time, etc) and data (metrics, params, and
        tags).
      properties:
        data:
          $ref: '#/components/schemas/mlflow-proxy_RunData'
        info:
          $ref: '#/components/schemas/mlflow-proxy_RunInfo'
        inputs:
          $ref: '#/components/schemas/mlflow-proxy_RunInputs'
      required:
        - data
        - info
        - inputs
      type: object
    mlflow-proxy_ErrorResponse:
      properties:
        error_code:
          $ref: '#/components/schemas/mlflow-proxy_ErrorCode'
        message:
          description: Error message
          type: string
      required:
        - error_code
        - message
      type: object
    mlflow-proxy_RunData:
      properties:
        metrics:
          description: Run metrics.
          items:
            $ref: '#/components/schemas/mlflow-proxy_Metric'
          type: array
        params:
          description: Run parameters.
          items:
            $ref: '#/components/schemas/mlflow-proxy_Param'
          type: array
        tags:
          description: Additional metadata key-value pairs.
          items:
            $ref: '#/components/schemas/mlflow-proxy_Tag'
          type: array
      required:
        - tags
      type: object
    mlflow-proxy_RunInfo:
      properties:
        artifact_uri:
          description: >-
            URI of the directory where artifacts should be uploaded.

            This can be a local path (starting with "/"), or a distributed file
            system (DFS)

            path, like ``s3://bucket/directory`` or ``dbfs:/my/directory``.

            If not set, the local ``./mlruns`` directory is  chosen.
          type: string
        end_time:
          description: Unix timestamp of when the run ended in milliseconds.
          type: integer
          format: int64
        experiment_id:
          description: The experiment ID.
          type: string
        lifecycle_stage:
          description: >-
            Current life cycle stage of the experiment : OneOf("active",
            "deleted")
          type: string
        run_id:
          description: Unique identifier for the run.
          type: string
        run_name:
          description: Name for the run.
          type: string
        start_time:
          description: Unix timestamp of when the run started in milliseconds.
          type: integer
          format: int64
        status:
          description: Current status of the run.
          enum:
            - RUNNING
            - SCHEDULED
            - FINISHED
            - FAILED
            - KILLED
          type: string
        user_id:
          description: >-
            User who initiated the run.

            This field is deprecated as of MLflow 1.0, and will be removed in a
            future

            MLflow release. Use 'mlflow.user' tag instead.
          type: string
      required:
        - artifact_uri
        - experiment_id
        - run_name
        - user_id
        - lifecycle_stage
        - run_id
        - start_time
        - status
      type: object
    mlflow-proxy_RunInputs:
      description: >-
        Run inputs.

        Experimental: This API may change or be removed in a future release
        without warning.
      properties:
        dataset_inputs:
          description: Dataset inputs to the Run.
          items:
            $ref: '#/components/schemas/mlflow-proxy_DatasetInput'
          type: array
      type: object
    mlflow-proxy_ErrorCode:
      description: Error code
      enum:
        - INTERNAL_ERROR
        - INVALID_STATE
        - DATA_LOSS
        - NOT_IMPLEMENTED
        - TEMPORARILY_UNAVAILABLE
        - DEADLINE_EXCEEDED
        - CANCELLED
        - RESOURCE_EXHAUSTED
        - REQUEST_LIMIT_EXCEEDED
        - ABORTED
        - RESOURCE_CONFLICT
        - ALREADY_EXISTS
        - NOT_FOUND
        - ENDPOINT_NOT_FOUND
        - RESOURCE_DOES_NOT_EXIST
        - PERMISSION_DENIED
        - CUSTOMER_UNAUTHORIZED
        - UNAUTHENTICATED
        - BAD_REQUEST
        - RESOURCE_ALREADY_EXISTS
        - INVALID_PARAMETER_VALUE
      type: string
    mlflow-proxy_Metric:
      properties:
        key:
          description: Key identifying this metric.
          type: string
        step:
          default: '0'
          description: Step at which to log the metric.
          type: integer
          format: int64
        timestamp:
          description: The timestamp at which this metric was recorded.
          oneOf:
            - format: int64
              type: integer
            - type: string
        value:
          description: Value associated with this metric.
          oneOf:
            - format: double
              type: number
            - type: string
      required:
        - key
        - value
        - step
        - timestamp
      type: object
    mlflow-proxy_Param:
      properties:
        key:
          description: Key identifying this param.
          type: string
        value:
          description: Value associated with this param.
          type: string
      required:
        - key
        - value
      type: object
    mlflow-proxy_Tag:
      properties:
        key:
          description: >-
            Name of the tag. Maximum size depends on storage backend.

            If a tag with this name already exists, its preexisting value will
            be replaced by the specified value. All storage backends are
            guaranteed to support key values up to 250 bytes in size. This field
            is required.
          type: string
        value:
          description: >-
            String value of the tag being logged. Maximum size depends on
            storage backend.

            All storage backends are guaranteed to support key values up to 5000
            bytes in size. This field is required.
          type: string
      required:
        - key
        - value
      type: object
    mlflow-proxy_DatasetInput:
      description: >-
        Experimental: This API may change or be removed in a future release
        without warning.
      properties:
        tags:
          description: >-
            A list of tags for the dataset input, e.g. a "context" tag with
            value "training"
          items:
            $ref: '#/components/schemas/mlflow-proxy_Tag'
          type: array
        dataset:
          $ref: '#/components/schemas/mlflow-proxy_Dataset'
      required:
        - dataset
        - tags
      type: object
    mlflow-proxy_Dataset:
      description: >-
        Represents a reference to data used for training, testing, or evaluation
        during the model development process.

        Experimental: This API may change or be removed in a future release
        without warning.
      properties:
        name:
          description: >-
            The name of the dataset. E.g. "my.uc.table@2" "nyc-taxi-dataset",
            "fantastic-elk-3" This field is required.
          type: string
        digest:
          description: >-
            Dataset digest, e.g. an md5 hash of the dataset that uniquely
            identifies it within datasets of the same name. This field is
            required.
          type: string
        source_type:
          description: >-
            Source information for the dataset. Note that the source may not
            exactly reproduce the dataset if it was transformed / modified
            before use with MLflow. This field is required.
          type: string
        source:
          description: >-
            The type of the dataset source, e.g. "databricks-uc-table", "DBFS",
            "S3", … This field is required.
          type: string
        schema:
          description: >-
            The schema of the dataset. E.g., MLflow ColSpec JSON for a
            dataframe, MLflow TensorSpec JSON for an ndarray, or another schema
            format.
          type: string
        profile:
          description: >-
            The profile of the dataset. Summary statistics for the dataset, such
            as the number of rows in a table, the mean / std / mode of each
            column in a table, or the number of elements in an array.
          type: string
      required:
        - name
        - digest
        - source_type
        - source
      type: object
  responses:
    mlflow-proxy_MLflowNativeError:
      description: The client issued a bad request to the server
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/mlflow-proxy_ErrorResponse'

````

## Related topics

- [The python-domino library](/cloud/reference/python-sdk/python-domino.md)
- [Search experiments](/api-reference/mlflow-experiments-and-runs/post-api20mlflowexperimentssearch.md)
- [Use Domino search](/cloud/platform-capabilities/features/collaboration/domino-search.md)
- [Search model versions](/api-reference/mlflow-models/get-api20mlflowmodel-versionssearch.md)
